Index: trunk/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 498)
+++ trunk/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 540)
@@ -69,4 +69,7 @@
   string cfg_ReconFile [MAX_LAYERS];
   Int nLayerNum;
+#if OUTPUT_LAYER_SET_INDEX
+  Int olsIdx;
+#endif
 #if AVC_BASE
   string cfg_BLReconFile;
@@ -110,4 +113,7 @@
 #if SVC_EXTENSION
   ("LayerNum,-ls", nLayerNum, 1, "Number of layers to be decoded.")
+#if OUTPUT_LAYER_SET_INDEX
+  ("OutpuLayerSetIdx,-olsidx", olsIdx, -1, "Index of output layer set to be decoded.")
+#endif
 #endif 
   ("MaxTemporalLayer,t", m_iMaxTemporalLayer, -1, "Maximum Temporal Layer to be decoded. -1 to decode all layers")
@@ -138,4 +144,8 @@
   m_tgtLayerId = nLayerNum - 1;
   assert( m_tgtLayerId >= 0 );
+#if OUTPUT_LAYER_SET_INDEX  
+  this->getCommonDecoderParams()->setOutputLayerSetIdx( olsIdx       );
+  this->getCommonDecoderParams()->setTargetLayerId    ( m_tgtLayerId );
+#endif
   for(UInt layer=0; layer<= m_tgtLayerId; layer++)
   {
@@ -201,4 +211,7 @@
       fprintf(stderr, "File %s could not be opened. Using all LayerIds as default.\n", cfg_TargetDecLayerIdSetFile.c_str() );
     }
+#if OUTPUT_LAYER_SET_INDEX  
+    this->getCommonDecoderParams()->setTargetDecLayerIdSet( &m_targetDecLayerIdSet );
+#endif
   }
 
Index: trunk/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecCfg.h	(revision 498)
+++ trunk/source/App/TAppDecoder/TAppDecCfg.h	(revision 540)
@@ -91,4 +91,7 @@
   std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
   Int           m_respectDefDispWindow;               ///< Only output content inside the default display window 
+#if OUTPUT_LAYER_SET_INDEX
+  CommonDecoderParams             m_commonDecoderParams;
+#endif
 
 public:
@@ -120,4 +123,7 @@
   
   Bool  parseCfg        ( Int argc, Char* argv[] );   ///< initialize option class from configuration
+#if OUTPUT_LAYER_SET_INDEX
+  CommonDecoderParams* getCommonDecoderParams() {return &m_commonDecoderParams;}
+#endif
 };
 
Index: trunk/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 498)
+++ trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 540)
@@ -145,4 +145,7 @@
   // main decoder loop
   Bool openedReconFile[MAX_LAYERS]; // reconstruction file not yet opened. (must be performed after SPS is seen)
+  Bool loopFiltered[MAX_LAYERS];
+  memset( loopFiltered, false, sizeof( loopFiltered ) );
+
   for(UInt layer=0; layer<=m_tgtLayerId; layer++)
   {
@@ -223,5 +226,6 @@
       }
     }
-    if (bNewPicture || !bitstreamFile)
+
+    if (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS)
     {
 #if O0194_DIFFERENT_BITDEPTH_EL_BL
@@ -230,5 +234,9 @@
       g_bitDepthC = g_bitDepthCLayer[curLayerId];
 #endif
-      m_acTDecTop[curLayerId].executeLoopFilters(poc, pcListPic);
+      if (!loopFiltered[curLayerId] || bitstreamFile)
+      {
+        m_acTDecTop[curLayerId].executeLoopFilters(poc, pcListPic);
+      }
+      loopFiltered[curLayerId] = (nalu.m_nalUnitType == NAL_UNIT_EOS);
 #if EARLY_REF_PIC_MARKING
       m_acTDecTop[curLayerId].earlyPicMarking(m_iMaxTemporalLayer, m_targetDecLayerIdSet);
@@ -256,4 +264,8 @@
         xFlushOutput( pcListPic, curLayerId );
       }
+      if (nalu.m_nalUnitType == NAL_UNIT_EOS)
+      {
+        xFlushOutput( pcListPic, curLayerId );        
+      }
       // write reconstruction to file
       if(bNewPicture)
@@ -316,4 +328,5 @@
   // main decoder loop
   Bool openedReconFile = false; // reconstruction file not yet opened. (must be performed after SPS is seen)
+  Bool loopFiltered = false;
 
 #if SYNTAX_OUTPUT
@@ -384,7 +397,11 @@
       }
     }
-    if (bNewPicture || !bitstreamFile)
-    {
-      m_cTDecTop.executeLoopFilters(poc, pcListPic);
+    if (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS)
+    {
+      if (!loopFiltered || bitstreamFile)
+      {
+        m_cTDecTop.executeLoopFilters(poc, pcListPic);
+      }
+      loopFiltered = (nalu.m_nalUnitType == NAL_UNIT_EOS);
     }
 
@@ -408,4 +425,8 @@
         xFlushOutput( pcListPic );
       }
+      if (nalu.m_nalUnitType == NAL_UNIT_EOS)
+      {
+        xFlushOutput( pcListPic );        
+      }
       // write reconstruction to file
       if(bNewPicture)
@@ -494,4 +515,7 @@
     m_acTDecTop[layer].setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
     m_acTDecTop[layer].setNumLayer( m_tgtLayerId + 1 );
+#if OUTPUT_LAYER_SET_INDEX
+    m_acTDecTop[layer].setCommonDecoderParams( this->getCommonDecoderParams() );
+#endif
   }
 
@@ -503,6 +527,6 @@
 
 /** \param pcListPic list of pictures to be written to file
-\todo            DYN_REF_FREE should be revised
-*/
+    \todo            DYN_REF_FREE should be revised
+ */
 #if SVC_EXTENSION
 Void TAppDecTop::xWriteOutput( TComList<TComPic*>* pcListPic, UInt layerId, UInt tId )
@@ -511,4 +535,9 @@
 #endif
 {
+  if (pcListPic->empty())
+  {
+    return;
+  }
+
   TComList<TComPic*>::iterator iterPic   = pcListPic->begin();
   Int numPicsNotYetDisplayed = 0;
@@ -730,5 +759,5 @@
 #endif
 {
-  if(!pcListPic)
+  if(!pcListPic || pcListPic->empty())
   {
     return;
